searchData={"items":[{"type":"module","doc":"This module provides the possibility to manage secrets and to watch for directory changes.\n\nIt's aimed at managing secrets rotation (typically credentials written by Vault). Thus,\nit wraps secrets in closures to avoid leaking and use a constant-time comparison function\nto mitigate timing attacks.\n\nhttps://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/sensitive_data\nhttps://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/timing_attacks","title":"SecretAgent","ref":"SecretAgent.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"SecretAgent.child_spec/1","ref":"SecretAgent.html#child_spec/1"},{"type":"function","doc":"Set the secret value of `secret_name` to `:erased`.\n\nIf `secret_name` does not exist, nothing happen.","title":"SecretAgent.erase_secret/2","ref":"SecretAgent.html#erase_secret/2"},{"type":"function","doc":"Return the secret value (a closure or `:erased`) corresponding to `secret_name`.\n\nAs a best practice, the secret will be erased (as if called by `erase_secret/2`).\nYou can override this behavior with the option `erase: false`.","title":"SecretAgent.get_secret/3","ref":"SecretAgent.html#get_secret/3"},{"type":"function","doc":"Set the secret value (wrapped in a closure) of `secret_name`.\n\nIf `secret_name` does not exist, it's added to existing secrets.","title":"SecretAgent.put_secret/3","ref":"SecretAgent.html#put_secret/3"},{"type":"function","doc":"Start `secret_agent` as a linked process.","title":"SecretAgent.start_link/1","ref":"SecretAgent.html#start_link/1"},{"type":"module","doc":"This module provides a function to compare secrets in constant time to\navoid timing attacks.","title":"SecretAgent.Compare","ref":"SecretAgent.Compare.html"},{"type":"function","doc":"Compares `lhs` and `rhs` binaries in constant time.","title":"SecretAgent.Compare.equal?/2","ref":"SecretAgent.Compare.html#equal?/2"},{"type":"function","doc":"iex> equal?(\"abc\", \"abc\")\n    true\n\n    iex> equal?(\"abc\", \"abcd\")\n    false","title":"Examples - SecretAgent.Compare.equal?/2","ref":"SecretAgent.Compare.html#equal?/2-examples"},{"type":"module","doc":"`secret_agent` emits several [`telemetry`](https://github.com/beam-telemetry/telemetry) events.","title":"SecretAgent.Telemetry","ref":"SecretAgent.Telemetry.html"},{"type":"module","doc":"* `[:secret_agent, :file_event]`\n  * _metadata_\n    * `:events` the filesystem events\n    * `:path` path to the file with events\n\n* `[:secret_agent, :changed_secret]`\n  * _metadata_\n    * `:secret_filename` filename of the secret that has changed\n\n* `[:secret_agent, :initial_loading]`\n  * _metadata_\n    * `:directory` directory in which initial loading took place\n    * `:secret_filename` filename of the secret that has been loaded\n\n* `[:secret_agent, :unwatched_events]`\n  * _metadata_\n    * `:events` the filesystem events that have been ignored\n    * `:path` path to the file with events","title":"Events - SecretAgent.Telemetry","ref":"SecretAgent.Telemetry.html#module-events"},{"type":"function","doc":"Call this function to have events logged automatically.","title":"SecretAgent.Telemetry.attach_logger/0","ref":"SecretAgent.Telemetry.html#attach_logger/0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}